



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Objective-C if语句处理 BOOL值不为1和0的情况</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Objective-C if语句处理 BOOL值不为1和0的情况</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 22:14:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>BOOL ，布尔值，在Objective-C ，BOOL类型被typedef为signed char（有符号的整型），YES被#define为1，NO被#define为0。<br /><br />
事实上，xcode的编译器仍然会把BOOL值看成8位二进制数，所以，如果BOOL值被赋值为非1和0，那么xocde的判断语句if会怎样处理呢？传进去的数值超过八位（short 或者int）又会怎么处理呢？<br /><br />
如果把超过八位的二进制数值传给BOOL，xcode会警告说数值会被转换成相应的8位数值，其实就是只处理低八位二进制数值：</p>
<p>　　　　　　　　<img referrerpolicy="no-referrer"src="https://images.cnblogs.com/cnblogs_com/panxiaochun/871986/o_%e5%b1%8f%e5%b9%95%e5%bf%ab%e7%85%a7%202016-12-22%20%e4%b8%8a%e5%8d%8810.53.29.png"><br /><br />
　　　　　　　　<img referrerpolicy="no-referrer"src="https://images.cnblogs.com/cnblogs_com/panxiaochun/871986/o_%e5%b1%8f%e5%b9%95%e5%bf%ab%e7%85%a7%202016-12-22%20%e4%b8%8a%e5%8d%8810.53.07.png"><br /><br />
　　　　　　　　<img referrerpolicy="no-referrer"src="https://images.cnblogs.com/cnblogs_com/panxiaochun/871986/o_%e5%b1%8f%e5%b9%95%e5%bf%ab%e7%85%a7%202016-12-22%20%e4%b8%8a%e5%8d%8810.53.47.png"><br /><br />
　　　　　　　　　　　　　　　　　　图 ： xcode警告数值被转换</p>
<p>编译运行测试程序得出的结果就是只有低八位的二进制数值全部为0（NO）时xcode的if语句才会判断为假，其它情况，即非0（NO）都为真。但是在Objective-C中只有1才代表YES，如果运行</p>
<pre class="prettyprint linenums"><code>    BOOL yes_or_no = 0xff70;<br />
    if (yes_or_no == YES ) {<br />
        NSLog(@&quot;yes&quot;);<br />
    }else<br />
    {<br />
        NSLog(@&quot;no&quot;);<br />
    }<br />
</code></pre>
<p>yes_or_no 的值为：112（被xcode转换为8位），这时打印结果为no；</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pjd479.html">swift-元组</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g5vml8.html">ios 利用airprint实现无线打印（配合普通打印机）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7jz3eq.html">控制器View的加载和内存警告流程图</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mx7ro9.html">Java 日志性能优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnlrk39.html">js基础知识温习：Javascript中如何模拟私有方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93l7vz9.html">gc是什么，什么时候需要gc</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xpdrm8.html">ExtJs之Element&period;select函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05kj4q.html">&lbrack;汇编学习笔记&rsqb;&lbrack;第五章&lbrack;BX&rsqb;和loop指令&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv6yyxq.html">Berkeley DB基础教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojkpy1q.html">WCF&lpar;1&rpar;----服务创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zoygx9.html">&lbrack;转&rsqb; iOS ABI Function Call Guide</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yjv4z8.html">第3章 Java语言基础----声明成员变量，对变量进行赋值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwljx9.html">windows转mac-开发环境搭建（一）：mac上搭建maven环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp4zxxq.html">Redis配置信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m67rj8.html">谷歌浏览器安装json格式化插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvloyy8.html">Django&plus;MongoDB批量插入数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mje1g08.html">也谈OpenStack中的虚拟机HA</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjdv70q.html">POJ 1953 World Cup Noise（递推）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppgjjz9.html">2018&period;07&period;17 HAOI2016 找相同字符（SAM）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn77peq.html">HTML5&plus;规范：Webview&lpar;管理应用窗口界面&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mr0y09.html">Winjs &ndash; 微软开源技术发布的 JavaScript  组件集</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rkx3rq.html">优秀案例：12个精美的设计工作室 &amp;amp&semi; 设计公司网站</a>
			</li>
						<li><a href="https://www.batexi.com/a/49574dzq.html">使用 jQuery Mockjax 插件模拟 Ajax 请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8erd2xq.html">web代理工具WebScarab</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96z1rvq.html">Autodesk hackathon 技术参考资料</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q26jlw9.html">&lbrack;转&rsqb;setValue和setObject的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ex4meq.html">Windows 7 安装&period;net framework 4&period;0 失败，错误HRESULT 0xc8000222解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9640448.html">DOM样式操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7el1q.html">Unbuntu&lowbar;14&period;04编译openjdk7</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8exmdkq.html">select接收后台返回值的解决方案</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
